/*

NODES
	height
	
PERIMETER
	path
	realcoord (formed with borders)
	triangles
	projectivity
	
HULL
	triangles
	solids
	
GRAPH
	nodes
	connectivity
	node perimeters
	
*/

var PRIM_NODE = function(position){
	this.position = position
}

var PRIM_PERIMETER = function(){
	
}

var PRIM_BAND = function(pA,pB,pE,pH){
	this.A = pA
	this.B = pB
	this.E = pE
	this.H = pH
	this.cut = function(pA,pB,pE,pH){
		if(pA>=this.B){return [this]}
		if(pB<=this.A){return [this]}
		if(pE>=this.H){return [this]}
		if(PH<=this.E){return [this]}
		//there is an intersection!
		var product = []
		if(pA>this.A){
			//left piece
			product.push(new PRIM_BAND(this.A,pB,Math.max(this.E,pE),Math.min(this.H,pH)))
		}
		if(pB<this.B){
			//right piece
			product.push(new PRIM_BAND(pB,this.B,Math.max(this.E,pE),Math.min(this.H,pH)))
		}
		if(pE>this.E){
			//bottom piece
			product.push(new PRIM_BAND(this.A,this.B,this.E,pE))
		}
		if(pH<this.H){
			//top piece
			product.push(new PRIM_BAND(this.A,this.B,pH,this.H))
		}
		return product
	}
}

function create_cube(){
	
	
}

var PRIM_WALL = function(inworld,outworld,height){
	this.height = height
	this.inworld = inworld
	this.outworld = outworld
	this.bands = [[0,1,0,height]]
	this.addPortal = function(ins outs,pE,pH){
		//find where ins/outs belong
		//shift inworld/outworld with new ins/outs
		var mark = 0
		var marked = []
		for(var ii=1;ii<this.inworld.length;ii++){
			if(ins[mark].distanceTo(this.inworld[0])<this.inworld[ii].distanceTo(this.inworld[0])){
				//this is the first insert
				this.inworld.splice(ii-1,0,ins[mark])
				this.outworld.splice(ii-1,0,outs[mark])
				for(var jj=0;jj<this.bands.length;jj++){
					if(this.bands[jj].A>=ii){
						this.bands[jj].A++
					}
					if(this.bands[jj].B>=ii){
						this.bands[jj].B++
					}
				}
				marked.push(ii)
				mark++
			}
			if(mark==2){break}
		}
		//now cut the bands around it
		for(var ii=0;ii<this.bands.length;ii++){
			this.bands = this.bands.concat(this.bands[0].cut(marked[0],marked[1],pE,pH))
			this.bands.splice(0,1)
		}
	}
	this.createMesh = function(){
		for(var ii=0;ii<this.bands.length;ii++){
			var geo = new THREE.Geometry()
			
		}
	}
	//surfaces
	//portals
	//regions
	
}