var Floor_Prim = function(){
	this.border = new Border_Widget()
	this.height = 256
}

var Room_Prim = function(){
	this.border = new Border_Widget()
	this.height = 192
	this.catWalks = []
}

var Portal_Prim = function(){
	this.targets = []
	this.position = new THREE.Vector3()
	this.width = 128
	this.height = 192
}

var Building_Prim = function(){
	this.baseElevation = 0
	this.floors = [new Floor_Prim()]
	this.rooms = []
	this.portals = []
}

var World_Prim = function(){
	this.border = Border_Widget()
	this.pathElevations = []
	this.buildings = []
	this.catWalks = []
	this.addBuilding = function(position){
		this.buildings.push(new Building_Prim())
	}
}


//The Base floor of a building is widened and formalized into a foundation
//Each floor is then inset by -8 HU
//Rooms can touch floor walls, and other rooms, but may not intersect.
//Rooms are inset by 8 HU