function Inset_Path(Target,width){
	
	var splits = []
	splits.push(Target[0].clone().sub(Target[Target.length-2]).normalize())
	for(var i=1;i<Target.length;i++){
		splits.push(Target[i].clone().sub(Target[i-1]).normalize())
	}
	
	//now to create the decension angles
	var raw_attractor
	var offset

	var geometry = []
	for(var i=0;i<Target.length-1;i++){
		//going toward the center is not the bisector
		raw_attractor = splits[i].clone().sub(splits[i+1]);
		raw_attractor.normalize();
		
		var back_angle = Math.acos(raw_attractor.dot(splits[i]));//angle between
		raw_attractor.divideScalar(Math.sin(back_angle));
		raw_attractor.multiplyScalar(width);
		var test_angle = new THREE.Vector3();
		test_angle.x = -splits[i].z;
		test_angle.z = splits[i].x;
		if(test_angle.dot(splits[i+1])<0){//convex
			geometry.push(Target[i].clone().sub(raw_attractor))
		}else{ //concave
			geometry.push(Target[i].clone().add(raw_attractor))
		}
	}
	geometry.push(geometry[0].clone());
	
	return geometry

}